import java.io.*;
import java.util.HashSet;
public final class StatCalc
{
    private StatCalc(){}
    
    public static void main(String[] args)
    {
        try
        {
            if (args.length < 7)
            {
                System.out.println("**Required Parameters**");
                System.out.println("1st: The first level to print, inclusive");
                System.out.println("2rd: The last level to print, inclusive");
                System.out.println("3th: The first job to print, inclusive");
                System.out.println("4th: The last job to print, inclusive");
                System.out.println("5th: The gender you want generics to stat as: 0 for male, 1 for female, 2 for Ramza, 3 for monster");
                System.out.println("6th: The first ability to print, inclusive");
                System.out.println("7th: The last ability to print, inclusive");
            }
            else
            {
                //put job names and ids into an array
                BufferedReader jobNameReader = new BufferedReader(new FileReader("jobNames.csv"));
                String[][] jobNames = new String[160][3];
                String line = jobNameReader.readLine();
                int counter = 0;
                while (line != null)
                {
                    String[] lineArray = line.split(",");
                    for (int n = 0; n < 3; n++)
                    {
                        jobNames[counter][n] = lineArray[n];
                    }
                    counter ++;
                    line = jobNameReader.readLine();
                }
                jobNameReader.close();
                
                
                //put stats into an array
                BufferedReader statReader = new BufferedReader(new FileReader("rawStats.csv"));
                int[][] rawStats = new int[4][5];
                line = statReader.readLine();
                counter = 0;
                while (line != null)
                {
                    String[] lineArray = line.split(",");
                    for (int n = 0; n < 5; n++)
                    {
                        int stat = Integer.parseInt(lineArray[n]);
                        rawStats[counter][n] = stat;// * 16384;
                    }
                    counter ++;
                    line = statReader.readLine();
                }
                statReader.close();
                
                //put jobs into an array
                BufferedReader jobReader = new BufferedReader(new FileReader("jobs.csv"));
                int[][] jobs = new int[160][10];
                line = jobReader.readLine();
                counter = 0;
                while (line != null)
                {
                    String[] lineArray = line.split(",");
                    for (int n = 0; n < 10; n++)
                    {
                        jobs[counter][n] = Integer.parseInt(lineArray[n]);
                    }
                    counter ++;
                    line = jobReader.readLine();
                }
                jobReader.close();
                
                //put skills into an array
                BufferedReader skillReader = new BufferedReader(new FileReader("abilities.csv"));
                int[][] skills = new int[512][3];
                line = skillReader.readLine();
                counter = 0;
                while (line != null)
                {
                    String lineArray[] = line.split(",");
                    for (int n = 0; n < 3; n++)
                    {
                        skills[counter][n] = Integer.parseInt(lineArray[n]);
                    }
                    counter ++;
                    line = skillReader.readLine();
                }
                skillReader.close();
                
                //Working area is here and down to end of try block
                int levelCounter = Integer.parseInt(args[0]);
                int levelMax = Integer.parseInt(args[1]);
                int jobCounter = Integer.parseInt(args[2]);
                int jobMax = Integer.parseInt(args[3]);
                for (; jobCounter <= jobMax; jobCounter++)
                {
                    int jobGender;
                    if (Integer.parseInt(jobNames[jobCounter][2]) == 4)
                    {//if we're dealing with a generic (besides bard and dancer)...
                        jobGender = Integer.parseInt(args[4]);
                    }//use value passed in with program as parameter.
                    else
                    {//if we're dealing with a bard, dancer, monster, or non-generic...
                        jobGender = Integer.parseInt(jobNames[jobCounter][2]);
                    }//use value in text file.
                    
                    long jobHP = (rawStats[jobGender][0]) * 16384;
                    long jobMP = (rawStats[jobGender][1]) * 16384;
                    int jobSP = (rawStats[jobGender][2]) * 16384;
                    int jobPA = (rawStats[jobGender][3]) * 16384;
                    int jobMA = (rawStats[jobGender][4]) * 16384;
                    
                    HashSet<Integer> zodiacBeasts = new HashSet<Integer>();
                    zodiacBeasts.add(60);
                    zodiacBeasts.add(62);
                    zodiacBeasts.add(64);
                    zodiacBeasts.add(65);
                    zodiacBeasts.add(67);
                    zodiacBeasts.add(69);
                    zodiacBeasts.add(73);
                    
                    //if (zodiacBeasts.contains(jobCounter))
                    //{//Comment this out until you know where the * 10 is applied.
                        //jobHP *= 10;
                        //jobMP *= 10;
                    //}//Applied to base stat, growth, or multiplier?
                    
                    int jobHPC = jobs[jobCounter][0];
                    int jobHPM = jobs[jobCounter][1];

                    int jobMPC = jobs[jobCounter][2];
                    int jobMPM = jobs[jobCounter][3];

                    int jobSPC = jobs[jobCounter][4];
                    int jobSPM = jobs[jobCounter][5];

                    int jobPAC = jobs[jobCounter][6];//squire pa growth
                    int jobPAM = jobs[jobCounter][7];//squire pa multiplier
                    
                    int jobMAC = jobs[jobCounter][8];
                    int jobMAM = jobs[jobCounter][9];
                    
                    if (jobGender == 0)
                    {
                        System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Male "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
                    }
                    else if (jobGender == 1)
                    {
                        System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Female "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
                    }
                    else if (jobGender == 2)
                    {
                        System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Ramza's "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
                    }
                    else
                    {
                        System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Monster "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
                    }
                    if (levelCounter == 1)
                    {
                        System.out.print(  "Level  1 - ");
                        if (((jobHP * jobHPM) / 1638400) < 100)
                        {
                            if (((jobHP * jobHPM) / 1638400) < 10)
                            {//1 digit
                                System.out.print("  " + ((jobHP * jobHPM) / 1638400) + " - ");
                            }
                            else
                            {//2 digits
                                System.out.print(" " + ((jobHP * jobHPM) / 1638400) + " - ");
                            }
                        }
                        else
                        {
                            if (((jobHP * jobHPM) / 1638400) >= 999)
                            {//not needed because impossible to have > 100 stats at level 1
                                System.out.print("999 - ");
                            }
                            else
                            {//3 digits, also not needed for same reasons
                                System.out.print(((jobHP * jobHPM) / 1638400) + " - ");
                            }
                        }
                        if (((jobMP * jobMPM) / 1638400) < 100)
                        {
                            if (((jobMP * jobMPM) / 1638400) < 10)
                            {//1 digit
                                System.out.print("  " + ((jobMP * jobMPM) / 1638400) + " - ");
                            }
                            else
                            {//2 digits
                                System.out.print(" " + ((jobMP * jobMPM) / 1638400) + " - ");
                            }
                        }
                        else
                        {
                            if (((jobMP * jobMPM) / 1638400) >= 999)
                            {//not needed because impossible to have > 100 stats at level 1
                                System.out.print("999 - ");
                            }
                            else
                            {//3 digits, also not needed for same reasons
                                System.out.print(((jobMP * jobMPM) / 1638400) + " - ");
                            }
                        }
                        if (((jobSP * jobSPM) / 1638400) < 10)
                        {
                            System.out.print(" " + ((jobSP * jobSPM) / 1638400) + " - ");
                        }
                        else
                        {
                            System.out.print(((jobSP * jobSPM) / 1638400) + " - ");
                        }
                        if (((jobPA * jobPAM) / 1638400) < 10)
                        {
                            System.out.print(" " + ((jobPA * jobPAM) / 1638400) + " - ");
                        }
                        else
                        {
                            System.out.print(((jobPA * jobPAM) / 1638400) + " - ");
                        }
                        if (((jobMA * jobMAM) / 1638400) < 10)
                        {
                            System.out.print(" " + ((jobMA * jobMAM) / 1638400));
                        }
                        else
                        {
                            System.out.print(((jobMA * jobMAM) / 1638400));
                        }
                        System.out.println();
                        levelCounter++;
                    }
                    for (int i = 2; i < 100; i++)
                    {
                        jobHP = jobHP + (jobHP / (jobHPC + (i - 1)));
                        jobMP = jobMP + (jobMP / (jobMPC + (i - 1)));
                        jobSP = jobSP + (jobSP / (jobSPC + (i - 1)));
                        jobPA = jobPA + (jobPA / (jobPAC + (i - 1)));
                        jobMA = jobMA + (jobMA / (jobMAC + (i - 1)));
                        if (i == levelCounter)
                        {
                            if (i <= 9)
                            {
                                System.out.print("Level  " + i + " - ");
                            }
                            else if (i > 9)
                            {
                                System.out.print("Level " + i + " - ");
                            }
                            if (((jobHP * jobHPM) / 1638400) < 100)
                            {
                                if (((jobHP * jobHPM) / 1638400) < 10)
                                {//1 digit
                                    System.out.print("  " + ((jobHP * jobHPM) / 1638400) + " - ");
                                }
                                else
                                {//2 digits
                                    System.out.print(" " + ((jobHP * jobHPM) / 1638400) + " - ");
                                }
                            }
                            else
                            {
                                if (((jobHP * jobHPM) / 1638400) >= 999)
                                {//max amount, maybe make room for 4 digits later?
                                    System.out.print("999 - ");
                                }
                                else
                                {//3 digits
                                    System.out.print(((jobHP * jobHPM) / 1638400) + " - ");
                                }
                            }
                            if (((jobMP * jobMPM) / 1638400) < 100)
                            {
                                if (((jobMP * jobMPM) / 1638400) < 10)
                                {//1 digits
                                    System.out.print("  " + ((jobMP * jobMPM) / 1638400) + " - ");
                                }
                                else
                                {//2 digits
                                    System.out.print(" " + ((jobMP * jobMPM) / 1638400) + " - ");
                                }
                            }
                            else
                            {
                                if (((jobMP * jobMPM) / 1638400) >= 999)
                                {//max amount, maybe make room for 4 digits later?
                                    System.out.print("999 - ");
                                }
                                else
                                {//3 digits
                                    System.out.print(((jobMP * jobMPM) / 1638400) + " - ");
                                }
                            }
                            if (((jobSP * jobSPM) / 1638400) < 10)
                            {
                                System.out.print(" " + ((jobSP * jobSPM) / 1638400) + " - ");
                            }
                            else
                            {
                                System.out.print(((jobSP * jobSPM) / 1638400) + " - ");
                            }
                            if (((jobPA * jobPAM) / 1638400) < 10)
                            {
                                System.out.print(" " + ((jobPA * jobPAM) / 1638400) + " - ");
                            }
                            else
                            {
                                System.out.print(((jobPA * jobPAM) / 1638400) + " - ");
                            }
                            if (((jobMA * jobMAM) / 1638400) < 10)
                            {
                                System.out.print(" " + ((jobMA * jobMAM) / 1638400));
                            }
                            else
                            {
                                System.out.print(((jobMA * jobMAM) / 1638400));
                            }
                            System.out.println();
                            if (levelCounter < levelMax)
                            {
                                levelCounter++;
                            }
                        }
                    }
                    levelCounter = Integer.parseInt(args[0]);
                }
            }
        }
        catch (Exception e)
        {
            System.out.println(e);
            e.printStackTrace();
            System.out.println("\n\n*.csv files must be in the same directory as MakeCSV.class\n\n");
        }
    }
}
